;
; bank2.asm - bank2 assembler
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
BANK		= 2
		.include config.def
		.include makro.def
		.include consts.def
		.include external.ram
		.include internal.ram
                .include man.ram

		*= $8000

		.fill $4000,$ff

		*= $a000
		.if DE32_EXISTS=0
config16test	.byte $ff
		.fi
		.byte $ff,$ff,$ff
		.include crosslnk.asm
		.include lowlevel.asm	;duplicated code!
		.include atapi.asm

buffer_start	.for iodhtoe=0,iodhtoe<MAX_BUFFERS,iodhtoe=iodhtoe+1
		.byte iodhtoe*8+ram_exp_buff_avail0
		.next

		.include channel15.asm
		.include misc.asm	;duplicated code!
		.include ram.asm	;duplicated code!
		.include math.asm	;duplicated code!
		.include man_hi.asm
		.include miscutil.asm

		.include trap.asm

                .if *>$9f85
                .error
                .fi
                
                *= $9f85
input		sta bank_port1	;0
		rts		;3
                .byte $ff,$ff,$ff,$ff,$ff
clrinput	sta bank_port1  ;9
		rts             ;12
                .byte $ff,$ff,$ff,$ff,$ff
numtoasc16	sta bank_port1  ;18
		rts             ;21
                .byte $ff,$ff,$ff,$ff,$ff
numtoasc24	sta bank_port1  ;27
		rts             ;30
                .byte $ff,$ff,$ff,$ff,$ff
man_printfullfree sta bank_port1  ;27
		rts             ;30
                .byte $ff,$ff,$ff,$ff,$ff
scrollbar       sta bank_port1  ;27
		rts             ;30
                .byte $ff,$ff,$ff,$ff,$ff
man_fastload_init sta bank_port1  ;27
		rts             ;30
                .byte $ff,$ff,$ff,$ff,$ff
man_fastload    sta bank_port1  ;27
		rts             ;30
                .byte $ff,$ff,$ff,$ff,$ff
man_fastsave_init sta bank_port1  ;27
		rts             ;30
                .byte $ff,$ff,$ff,$ff,$ff
man_fastsave    sta bank_port1  ;27
		rts             ;30

		*= $8000

		.include messages.asm	;duplicated code!
		.include man.asm

		.if *>$9e60
		.error "Bank2 block $8000-$9e60 over!"
		.fi
