;
; c128.asm - c128 specific part
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
crtc_init_if128	.proc
		lda $d030		;C128?
		lsr
		bcs npl
		pha
		ldx #0
		jsr setupcrtcregisters	;C128 crtc init
		lda $d600
		and #7
		beq nv1
		ldx #crtcdefaultv1-crtcdefault
		jsr setupcrtcregisters	;version 1/2 init
nv1		pla
		beq npl
		ldx #crtcpal-crtcdefault
		jsr setupcrtcregisters	;pal init
npl		rts
		.pend

crtc_logo	.proc
		jsr crtc_upload_cset

		jsr crtc_clrscr

		jsr setcrtcreg0013

		lda #$1f
		sta $d600

		ldy #0
                geq vs
nd		cmp #13
		bne *+4
		lda #32
		and #63
		jsr setcrtcreg.in
		iny
vs		lda copyright-5,y
		bne nd
		rts
		.pend

crtc_clrscr	.proc
		jsr setcrtcreg0013
		ldx #$1f
		lda #32
		jsr setcrtcreg
		ldy #16
                dex
uf		jsr setcrtcreg0
		dey
		bne uf

		inx
		lda #15
		jsr setcrtcreg
		ldy #16
		lda #254
                dex
uf2		jsr setcrtcreg
		lda #0
		dey
		bne uf2
		rts
		.pend

crtc_upload_cset .proc
		php
		sei
		ldx #$12
		lda #>$2000
		jsr setcrtcreg
		inx
;		lda #<$2000
        	jsr setcrtcreg0

		tay
		sty $14
		lda #$d0
		sta $15

nu		lda #$1f
		sta $d600

nu2		ldx #$33
		stx $01
		lda ($14),y
		ldx #$37
		stx $01
		jsr setcrtcreg.in
		iny
                tya
                and #7
		bne nu2
		ldx #$1e
		lda #8
		jsr setcrtcreg
                tya
		bne nu
		inc $15
		lda $15
		and #15
		bne nu
		sta $15
		plp
		rts
		.pend

setcrtcreg0013  .proc
		ldx #$13
		jsr setcrtcreg0
                dex
setcrtcreg0     .proc
		lda #0
setcrtcreg	.proc
		stx $d600
in		bit $d600
		bpl *-3
		sta $d601
		rts
		.pend

setupcrtcregisters .proc
lp		ldy crtcdefault,x
		bmi end
		inx
		lda crtcdefault,x
		inx
		sty $d600
		sta $d601
		bpl lp
end		rts
		.pend

crtcdefault	.byte $00,$7E,$01,$50,$02,$66,$03,$49
		.byte $04,$20,$05,$00,$06,$19,$07,$1D
		.byte $08,$00,$09,$07,$0A,$20,$0B,$08
		.byte $0C,$00,$0D,$00,$0E,$00,$0F,$00
		.byte $14,$10,$15,$01,$17,$08,$18,$20
		.byte $19,$40,$1A,$F0,$1B,$00,$1C,$20
		.byte $1D,$07,$22,$7D,$23,$64,$24,$05
		.byte $16,$78,$FF
crtcdefaultv1	.byte $19,$47,$FF
crtcpal		.byte $04,$26,$07,$20,$FF
