;
; man.asm - File manager lower half
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;
; starts in cfg_16
;

DECORATION	= 1	   	;If 0 then old window decoration

manager		.proc
		pha
                .if SUPERCPU=1
                jsr scpu_no_opt		;no optimization, sprites!!!
                .fi

		lda #$37
		sta $01
                #sta_cfg_open
		jsr manager_data_swap

		sec
                jsr restorescreen.save

		#sta_cfg_open
		ldx #7
ld              lda setup_mancolors_exp-1,x
		tay
                lsr
                lsr
                lsr
                lsr
                sta manager_colors+6,x
                tya
                and #15
                sta manager_colors-1,x
                dex			;set default colors
                bne ld
                stx man_valid
                stx man_valid+1
                asl manager_dircolor
                sec
                ror manager_dircolor
                
                pla
                cmp #"!"
                beq cler

		jsr man_check_sign	;cfg16
                beq redraw

cler		lda ActualDev
                cmp #31
                bcs *+6
                cmp #8
                bcs *+4
                lda #12
		sta man_drive
		sta man_drive+1
                ldx #5
ldk             lda defaultp-1,x
                sta man_relpath-1+$000,x
                sta man_relpath-1+$100,x
                dex
                bne ldk
                txa
                ldx #2
rr      	sta man_bar-1,x
		sta man_el_l-1,x
		sta man_el_h-1,x
                sta man_partition-1,x
                dex
                bne rr
		stx man_selectedwin		;0
                stx man_jumpon
                inx
                stx man_parlist
                stx man_parlist+1
                lda #128
                sta man_font
                
                #sta_cfg_open
		lda setup_boot_drive_exp
                sta ActualDev
                sta man_plugin_drive
                
                ldx #11
                stx ActualFNLength
ie              lda iu-1,x
                sta $200-1,x
                dex
                bne ie
                stx ActualFilename
                stx ActualSecAddr
                stx man_plugins
                lda #2
                sta ActualFilename+1
                txa
                stx msgmode
                ldx #<man_plugins
                ldy #>man_plugins
                jsr newload_t

		lda #<man_input
       		ldy #>man_input
               	jsr ident_drive.in
               	lda man_floppy
               	sta man_floppy+1
               	lda man_cmd
               	sta man_cmd+1

		clc
		jsr man_check_sign.set
                gcc redraw
                
iu              .text "1//:man,usr"
                
restart		jsr manager_data_swap
		.if SUPERCPU=1
                jsr scpu_no_opt		;no optimization, sprites!!!
                .fi

redraw		.if (((JIFFYDOS_ACCEL=1) & (SUPERCPU=0)) | (DOLPHINDOS_ACCEL=1)) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                sta cfg_open
                .if SUPERCPU=1
                lda #1
                sta dos_accel_internal_exp
                .else
		sec
		rol dos_accel_internal_exp
                .fi
                sta cfg_16
		.fi
                jsr getcconv

		ldx #4
                ldy #8
                lda #8+48*4
                sec
ldf		pha
		lda manager_bar_color
		sta $d027,x
                lda #35
                sta $7f8,x
                pla
                sta $d000,y
                sbc #48
                dey
                dey
                dex
                bpl ldf
		lda #128
		sta 650
                sta 657
		asl
                sta $d015
		sta $d010
		sta 198
		sta msgmode
		sta $d017
		sta $d01c
		jsr bary
		ldx #63
l		sta $08c0,x
		cpx #24
                bne *+4
                lda #255
		dex
		bpl l
                lda #6
                sta man_savedwind
                lda #<man_winstore
                sta man_savedwin
                lda #>man_winstore
                sta man_savedwin+1

		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda manager_brcolor
		sta $d020
		lda manager_bgcolor
		sta $d021
		lda #200
		sta $d016
		lda #27
		sta $d011
                lda man_font
                sta m_d018
                ldx #22
                asl
                bpl *+4
                ldx #20
		stx $d018
		lda #3
		sta $dd00
		lda #63
		sta $dd02
                lsr			;lda #%00011111
		sta $d01b
		sta $d01d
                lda manager_misc_color
                sta 646
                jsr clrscr

                ldx #19
ll              lda virtualcall-1,x
		sta man_virtual_c-1,x
                dex
                bne ll

                jsr topdir	     ;cfg16

		lda man_selectedwin
		pha
                jsr updateselectedwin
		jsr winselcolupdate	;cfg16

		#stz_a selectedwin
		#stz_aa man_oldsc_h
		#stz_aa man_oldsc_h+1
                #stz_aa man_virtual
                #stz_aa man_virtual+1
                #stz_aa man_redirect
                jsr killvirtualredrwincap
		inc selectedwin
                jsr killvirtualredrwincap

                .if SUPERCPU=1
                sei
                sta scpu_hwenable
                sta scpu_basic		;full optimization
                sta scpu_hwdisable
                cli
                .fi

iy		lda $dc01
		eor #$7f
		beq iy

		pla
                jsr updateselectedwin
		jsr changepanelforce
                lda man_jumpon
                pha
                #stz_a man_jumpon
		jsr main_reload2
                pla 
                sta man_jumpon
		jsr scrollbar
                jsr changepanelforce
		jsr main_reload2
		jsr scrollbar
                jsr topdir

klp		lda #%00011111
		sta $d015
		jsr vbn
		#jmps klp

vbn		jsr placebar
		jsr scrollbar

kllp		lda 651
		lsr
		beq xf
		lda #2
		sta 651
xf
		lda 653
		lsr
		lsr
		bcs topmenu	;C= key
		lsr
		bcc u		;control
		jsr changepanel
		jsr changepanel2
		lda #4
u2		bit 653
		bne u2		;wait release

u		jsr $f142
		beq kllp
		ldx selectedwin
                
                cmp #"a"
                bcc nq
                cmp #"z"+1
uu              bcc main_quick
nq	        cmp #"A"
		bcc nq2
                cmp #"Z"+1
		bcc uu
nq2
		ldy #256-3
dh		iny
		iny
		iny
		cpy #funce-func
		beq nn
		cmp func,y
		bne dh
                
                cpy #funce2-func
                bcc bd
                #stz_a $d015
bd
		lda func+2,y
		pha
		lda func+1,y
		pha
nn		rts

defaultp	.text "cd//",0

func		.byte 17		;down
		.word main_down-1
		.byte 145		;up
		.word main_up-1
		.byte 19		;home
		.word main_home-1
		.byte 137		;f2
		.word main_home-1
		.byte 133		;f1
		.word main_pgup-1
		.byte 157		;left
		.word main_pgup-1
		.byte 136		;f7
		.word main_pgdn-1
		.byte 29		;right
		.word main_pgdn-1
		.byte 140		;f8
		.word main_end-1
		.byte 147		;clr
		.word main_end-1
		.byte "*"		;*
		.word main_invselect-1
		.byte 192		;*
		.word main_invselect2-1
		.byte "+"		;+
		.word main_allselect-1
		.byte 219		;+
		.word main_allselect2-1
		.byte "-"		;-
		.word main_noneselect-1
		.byte 221		;-
		.word main_noneselect2-1
		.byte 20		;del
		.word main_select-1
                .byte 94		;^
                .word main_eject-1
funce2
		.byte "1"		;1
		.word main_reload-1
		.byte "."		;.
		.word main_parentdir-1
		.byte "/"		;/
		.word main_rootdir-1
		.byte "3"		;3
		.word main_view-1
		.byte 95		;<-
		.word main_exit-1
		.byte 13		;return
		.word main_return-1
		.byte 141		;sh+return
		.word main_shreturn-1
		.byte "5"		;5
		.word main_copy-1
		.byte "6"		;6
		.word main_rename-1
		.byte "7"		;7
		.word main_mkdir-1
		.byte "8"		;8
		.word main_delete-1
                .byte "9"		;9
                .word main_command-1
funce

txtloading	.byte 13,13,2,2,"loading"," "+128,"dir",0
txttoomany	.byte 13,13,29,29,"too"," "+128,"many"," "+128
		.byte "files","!"+128,0
                
virtualcall    	sei		;1
                sta cfg_stnd
		inc $01		;2
		jsr $d000	;3
                dec $01		;2
                sta bank_port2
                sta cfg_16
                cli		;1
                rts		;1
		.pend
;---------------------------
; Main quick search
;
main_quick	.proc
		sta man_jumpon
                #stz_a man_jumpon+1
                #stz_aa man_jumpontype
                jsr man_jumponfile2
                #jmps printdir
                .pend
;---------------------------
; Main (de)select file
;
main_select	.proc
		jsr calc_filepos_cursor
		jsr man_toggle_sel
		jsr printdirandstat
		ldx selectedwin
;---------------------------
; Main cursor down
;
main_down	.proc
		ldy man_el_h,x
		lda man_el_l,x
		sec
		adc man_bar,x
		bcc *+3
		iny
		cmp man_files_l,x
		tya
		sbc man_files_h,x
		bcs x
		lda man_bar,x
		cmp #10
		beq o2
		inc man_bar,x
x		rts

o2		inc man_el_l,x
		bne y
		inc man_el_h,x
y		#jmps printdir
		.pend
;---------------------------
; Main cursor up
;
main_up		.proc
		lda man_bar,x
		beq o1
		dec man_bar,x
x		rts

o1		lda man_el_l,x
		bne py
		lda man_el_h,x
		beq x
		dec man_el_h,x
py		dec man_el_l,x
		#jmps printdir
		.pend

;---------------------------
; Main reload dir
;
main_reload2	.proc
		jsr ident_drive
                jsr same_dir
                bne main_reload
in              ldx selectedwin+1
                lda man_valid,x
                beq main_reload
                jsr man_copypanel
                #jmps main_reload.in

main_reload	.proc
		jsr mloaddir
		jsr sortdir
in		jsr man_jumponfile
		ldx selectedwin
                lda #1
                sta man_valid,x
		txa
                lsr
		ldy #15
xu		ldx man_dirmem1-26,y
		bcc rp
                ldx man_dirmem2-26,y
rp              lda cconv,x
		eor #128
                bcs rp1
                sta $43f,y
                bcc rp2
rp1             sta $61f,y
rp2		dey
		bpl xu
		gmi printdirandstat
;---------------------------
; Main invert selection
;
main_invselect2	.proc
		lda #64
		.byte SKIP2
main_noneselect2 .proc
		lda #65
                .byte SKIP2
main_allselect2	.proc
		lda #192
		.byte SKIPLDA0
main_invselect	.proc
		#lda0
		.byte SKIP2
main_allselect	.proc
		lda #128
		.byte SKIP2
main_noneselect	.proc
		lda #1
		sta m_ascii+3

		#stz_a m_ascii+1
		#stz_aa m_ascii+2

lp		ldy selectedwin
		#ldatax m_ascii+1
		cmp man_files_l,y
		lda m_ascii+2
		sbc man_files_h,y
		bcs ss
		lda m_ascii+2
                lsr
		txa
		jsr calc_filepos
                bit m_ascii+3
		bvs k1
                jsr man_dir
                bmi k			;directory?
k1		lda m_ascii+3
		and #$81
		beq k2
		jsr man_sel
		bpl k
k2		jsr man_toggle_sel
k		inc m_ascii+1
		bne lp
		inc m_ascii+2
		#jmps lp

ss		#jmps printdirandstat
		.pend

;---------------------------
; Main go to parent dir
;
main_parentdir	.proc
		jsr man_cdpp
in		jsr showerror
		#jmps main_reload
		.pend
;---------------------------
; Main go to root dir
;
main_rootdir	.proc
		jsr man_cdroot
                ldx selectedwin
                #stz_a man_virtual,x
                lda #1
		sta man_parlist,x
		gne main_parentdir.in
		.pend

;---------------------------
; Main viewer
;
main_view	.proc
		jsr no_files_or_partlist_or_virtual
		beq err

		jsr calc_filepos_cursor
                jsr man_dir
                bmi err

		jsr man_copyfname

		ldy #255
                ldx #0
                clc
                .byte SKIP1
dp2		sec
		.byte SKIP1
dp              inx
		iny
		lda man_plugins,y
                sta cconv,x
                bne dp
                bcc dp2
		stx ActualFNLength
in
		lda man_plugin_drive
		sta ActualDev

		lda #>cconv
		sta ActualFilename+1
		sta ActualSecAddr

		#lda0
		sta ActualFilename
		jsr newload_t

		lda Status
		eor #$40
		bne pr
		bcc ui
pr		jsr read_errchannel
		jsr showerror
ie		jsr setdev
		#jmps getcconv

err		rts

ui		cpy #$d0
		bcc nvirt
		ldx selectedwin+1
                lda man_virtual,x
                bne ie           ;1 virtual filesystem at a time!
                sta man_virtual_at;VIRTUAL_INIT
                jsr setdev
		ldx #<$201
		ldy #>$201
		lda $200
                pha
                jsr man_virtual_c
                pla
                jsr setname201
                jsr rel_path_m_p1s
                lda #":"
                dey
                sta (m_p1),y
                jsr append_actualfn_to_path
                jsr topdir
		ldx selectedwin
		lda #1
                sta man_virtual,x
                jsr ie
                #jmps main_reload

nvirt		pla
		pla

		jsr setdev
                #stz_a man_valid
                #stz_aa man_valid+1
                
                ldy #255
np              iny
		lda $201,y
                sta man_jumpon,y
                eor #","
                bne np
                sta man_jumpon,y
                ldx #0
np2             lda $202,y
		iny
                cpy $200
                bcc xj
                lda #32
                dey
xj		sta man_jumpontype,x
                inx
                cpx #3
                bcc np2

		jsr manager_data_swap2
		#psr manager.restart
		#psr gotobank0back
		#psr exit2basic
		#psr $1003
                .if SUPERCPU=1
                jsr scpu_default_opt
                .fi
		ldx #<$201
		ldy #>$201
		lda $200
		jmp exit2basic
		.pend
;---------------------------
; Main exit
;
main_exit	.proc
		jsr savedrawwin
                .word $571
		.byte 20,6
		.word txtexit

		jsr waitkey_restorewin

		jsr $f142
		cmp #"y"
		beq exit
		cmp #"1"
		beq exit 		;exit
                rts

exit		pla
		pla
                jsr manager_data_swap2andrestore
                .if SUPERCPU=1
                jsr scpu_default_opt
                .fi
		.if (((JIFFYDOS_ACCEL=1) & (SUPERCPU=0)) | (DOLPHINDOS_ACCEL=1)) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                #lda0
                sta dos_accel_internal_exp
                .fi
		pla
		pla
		#psr $e37b
		jmp exit2basic

txtexit		.byte 13,13,2,1,"quit"," "+128,"this"," "+128,"soft","?"+128,13,13
		.byte 2,7,"y","/"+128,"n",0
		.pend
;---------------------------
; Main return
;
;Virtual filesystem:
;$d000-$ffff
;$d000 init     (x,y filename, a namelength)
;$0334 select   (x,y file/dir name ends on 0)
;$0336 list dir (x,y where) return: x,y read bytes
;$0338 read     (x,y where a=size) return: x,y read bytes
;$033a write    (x,y where a=size) return: x,y bytes writen
;$033c mkdir    () return: a
;$033e rm       () return: a
;$0340 rmdir    () return: a

main_return	.proc
		#lda0
		.byte SKIP2
main_shreturn	.proc
		lda #1
		sta ActualSecAddr
		lda man_files_l,x
		ora man_files_h,x
		beq x
                lda man_parlist,x
                lsr
                beq tu
		sta man_parlist,x
                jsr calc_filepos_cursor
                #lda0
                tay
                jsr man_get
                sta man_input+2
                jsr changepart
                jsr man_cdroot
                #jmps uf

x		rts

tu	       	jsr calc_filepos_cursor
		jsr man_dir
                bpl nd
		jsr man_cd
uf		lda m_p1+1
		pha
		jsr showerror
                pla
		bcc failed
                bne failed

		jsr append_actualfn_plus3_to_path
		jsr topdir

failed		#jmps main_reload

nd		ldx selectedwin
		lda man_virtual,x
                bne x

		jsr man_ext
		cmp #"c"
		bne nd2
		cpx #"b"
		bne nd2
		cpy #"m"
		bne nd2
		jsr man_cd2
		#jmps uf

nd2		jsr man_copyfname

		#sta_cfg_open
                ldx #255
tip             inx
                lda $201,x
                cmp #","
                bne ko
                #lda0
ko              sta direntry_name_exp,x
		bne tip
                #txy_a
                ldx #253
tip2            iny
                lda $201,y
                cpy $200
                bcc ko2
                #lda0
ko2		sta direntry_filetype_exp-253,x
		inx
		bne tip2
                lda #FTYPE_NORMAL | FATTR_CLOSED
                sta direntry_attrib_exp
                .if DIRMODE_CFS=(FTYPE_NORMAL | FATTR_CLOSED)
                lda #DIRMODE_CFS+1
                .fi
                sta direntry_mode_exp	;not cfs
                #stx_l_a wildcard_end_exp
                
                jsr OP_save_zeropage

		lda #<(man_plugins-1)
                sta current_path
		lda #>(man_plugins-1)
                sta current_path+1
                .if SUPERCPU=1
                stz current_path+2
                .fi

                jsr inc_cp_lda_ldy0
                beq nomx       		;no plugin list

		#sta_cfg_16
                
		ldx #0
nu2             sta cconv,x
                jsr inc_cp_lda_inx
                bne nu2
                stx m_p2

nu              jsr inc_cp_lda		;skip viewer
		bne nu
                
                #sta_cfg_open

		lda ActualSecAddr
		bne nom
		
retry           jsr inc_cp_lda
nomx            beq nom			;end of plugin list

		#sta_cfg_16
                ldx m_p2
dm		sta cconv,x
		jsr inc_cp_lda_inx
		bne dm
		stx ActualFNLength
                #sta_cfg_open
                
                jsr inc_cp_lda
                beq nom

                jsr check_wildcards

dm2		jsr inc_cp_lda_ldy0
		beq hi
                eor #","
                bne dm2
                jsr inc_cp_lda
                bcs dd

		pha
                jsr check_wildtype
                pla
		
dd		beq hi

dm3		jsr inc_cp_lda_ldy0
                bne dm3

hi		bcs retry	      ;no match

		jsr OP_restore_zeropage
		#sta_cfg_16

		#jmps main_view.in

nom		jsr OP_restore_zeropage
		lda $200
                sta ActualFNLength
		lda ActualSecAddr
		bne y
		lda #1
		sta load_autostart_exp	;autostart
y		pla
		pla
		#sta_cfg_16
                jsr manager_data_swap2andrestore
		lda #128
		sta msgmode
		asl
		sta $0a
		.if (((JIFFYDOS_ACCEL=1) & (SUPERCPU=0)) | (DOLPHINDOS_ACCEL=1)) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                sta dos_accel_internal_exp
                .fi
                .if SUPERCPU=1
                jsr scpu_default_opt
                .fi
		pla
		pla
		#psr $e16f
		jmp exit2basic

inc_cp_lda_ldy0 ldy #0
inc_cp_lda_inx  inx
inc_cp_lda     	inc current_path
		bne *+4
                inc current_path+1
                lda (current_path),y
                rts
		.pend

;---------------------------
; Main go home
;
main_home	.proc
		jsr gotop
		#jmps printdir
		.pend

;---------------------------
; Main PgUp
;
main_pgup	.proc
		lda man_bar,x
		bne dpy2
		lda man_el_l,x
		sec
		sbc #11
                bcs ndn
		dec man_el_h,x
		bmi main_home
ndn		sta man_el_l,x
		#jmps printdir

dpy2		#stz_a man_bar,x
		rts
		.pend

;---------------------------
; Main PgDn
;
main_pgdn	.proc
		lda #10
		cmp man_bar,x
		bne dpy2
		lda #21-1
		adc man_el_l,x
		tay
                #lda0
		adc man_el_h,x
		pha
		tya
		cmp man_files_l,x
		pla
		sbc man_files_h,x
		bcs main_end
		lda man_el_l,x
		adc #11
                bcc main_pgup.ndn
		inc man_el_h,x
                gcs main_pgup.ndn

dpy2		ldy man_files_h,x
		bne u
		cmp man_files_l,x
		bcs main_end
u		sta man_bar,x
		rts
		.pend
;---------------------------
; Main end
;
main_end	.proc
		lda #10
		ldy man_files_h,x
		bne us
		cmp man_files_l,x
		bcc us
		lda man_files_l,x
		sbc #1
		bcs vf
		#lda0
vf		sta man_bar,x
		rts

us		sta man_bar,x
		lda man_files_l,x
		sec
		sbc #11
		sta man_el_l,x
		tya
		sbc #0
		sta man_el_h,x
		#jmps printdir
		.pend
;---------------------------
; Main eject
;
I_UI		= 6
I_RD		= 9
I_S		= 13

main_eject	.proc
		ldy #0
putandexecinput .proc
		ldx #$60
le              lda uo,y
		bmi ji
                sta man_input-$60,x
                iny
                inx
                bne le
ji      	#jmps do_errchannel

uo              .text "u0>e1",0
		.text "ui",0
                .text "rd:",$80
                .text "s:",$80
		.pend
;---------------------------
; Identify drive
;
;73,CBM DOS V2.6 1541,00,00
;73,JIFFYDOS 5.0 1541,00,00
;73,CBM DOS V3.0 1570,00,00
;73,CBM DOS V3.0 1571,00,00
;73,JIFFYDOS 6.0 1571,00,00
;73,CBM DOS V3.1 1571,00,00
;73,COPYRIGHT CBM DOS V10 1581,00,00
;73,(C) 1989 JIFFYDOS 6.0 1581,00,00
;73,CMD FD DOS V1.40,00,00
;73,CMD RL DOS V2.06,00,00
;73,CMD HD DOS V1.90,00,00
;73,CMD HD DOS V1.92,00,00

ident_drive	.proc
		ldx selectedwin
                lda posl,x
                ldy posh,x

in		sta m_p5
		sty m_p5+1

		lda #160
		ldy #7
i		sta (m_p5),y
		dey
		bpl i

		#stz_a man_cmd,x
		lda #1
		sta man_floppy,x

		ldy #I_UI
		jsr putandexecinput

		lda man_errchannel
		cmp #"7"
		bne n5

		ldx #4
lk		lda man_errchannel+2,x
		cmp id,x
		bne kq
                dex
                bpl lk
		ldx selectedwin
                rol man_cmd,x
                lda #","
                sta man_errchannel+9
                ldx #2
                gne kxx

kq      	ldx #2
		lda #","
n		inx
		beq n5
		cmp man_errchannel,x
		bne n
		lda #" "
nn		dex
		beq n5
		cmp man_errchannel,x
		bne nn
kxx		ldy #0
n3		inx
		lda man_errchannel,x
		cmp #","
		beq n6
		and #63
		ora #128
		sta (m_p5),y
		iny
		cpy #8
		bcc n3

n6		ldy #1
		lda (m_p5),y
		cmp #"5"+128
		bne n5
		dey
		lda #"1"+128
		cmp (m_p5),y
		bne n5
		ldy #3
		cmp (m_p5),y
		bne n7
		dey
		lda (m_p5),y
		cmp #"4"+128
		beq n4
		cmp #"7"+128
		beq n4
		cmp #"8"+128
		beq n4
                gne n5
n7		lda (m_p5),y
		cmp #"0"+128
		bne n5
		dey
		lda (m_p5),y
                cmp #"7"+128
                beq n4
n5		ldx selectedwin	;no 1541/1571/1581/1570
		lsr man_floppy,x
n4		rts    
id		.text ",cmd "

posl		.byte <$430
		.byte <$610
posh    	.byte >$430
		.byte >$610

		.pend
;---------------------------
; Do chdir
;
man_cd2		.proc
		lda #"/"
		ldx #"0"
		gne man_cd.in

man_cd		.proc
		lda #"c"
		ldx #"d"
in		sta $201
		stx $202
		lda #":"
		sta $203
                jsr ispp
                beq man_cdpp

		ldx #3
		jsr man_copyfname3

                #lda0
                sta m_p1+1
		geq read_errchannel.inn
		.pend
;---------------------------
; Go to root
;
man_cdroot	.proc
		jsr rel_path_m_p1
                ldy #4
                #lda0
                sta (m_p1),y
                dey
nu              lda #"/"
                sta man_input+3
		ldx #4
		gne man_cdpp.in

in		jsr rel_path_m_p1
		ldx selectedwin
                #stz_a man_virtual,x
		ldy #3
		gne nu
;---------------------------
; Go to parent
;
man_cdpp	.proc
	    	jsr rel_path_m_p1s
                cpy #4
                bne kx
                jsr changepanel
                #ldatax selectedwin+1
                jsr updateselectedwin
                lda #"0"
                sta man_input
                lda #3
                sta man_parlist,x
                lda man_drive,x
                sta ActualDev
                rts

vir		jsr killvirtual
		ldx selectedwin
                lsr man_virtual,x
;                tax
;                pla
;nu              sta man_jumpon,x
;                inx
;                cpx #16
;                bcs se
;                iny
;                lda (m_p1),y
;                cmp #"/"
;                bne nu
;se              #lda0
;                sta man_jumpon,x

                lda #"0"
                sta man_input
                jsr topdir
                lda #VIRTUAL_EXIT
                sta man_virtual_at
                jmp man_virtual_c

kx              dey
jcn             dey
		cpy #5
		bcc man_cdroot.in
                lda (m_p1),y
                cmp #":"
                beq vir
                cmp #"/"
                bne jcn

		ldx #3
		lda #95
in      	sta man_input+2
		lda #"d"
		sta man_input+1
		lda #"c"
		sta man_input
		lda #"/"
		sta (m_p1),y
                iny
                lda (m_p1),y
                pha
		#lda0
		sta man_input,x
                sta (m_p1),y

                tax
                pla
nu              sta man_jumpon,x
                inx
                cpx #16
                bcs se
                iny
                lda (m_p1),y
                cmp #"/"
                bne nu
se              #lda0
                sta man_jumpon,x
                jsr jumptypedir

                jsr topdir
                
;---------------------------
; Execute command, and print result
;
do_errchannel	.proc
                jsr setnameinput

		ldy #0
iy		lda (ActualFilename),y
		beq ie
		iny
		bne iy

ie
		.byte SKIP2
;---------------------------
; Check error channel
;
read_errchannel	.proc
		ldy #0
		sty ActualFNLength

inn		lda #15
		sta ActualSecAddr
                ldx man_redirect
                beq no
                txa
no		sta ActualLogical
                bne okp

		jsr newopen_t
		bcc okp
ee		jsr basic_error
		#jmps uy

okp		ldx ActualLogical
		jsr newchkout_t
		bcs ee
                lda man_redirect
                beq no3
                ldx ActualFNLength
                beq no3
                ldy #0
nk              lda (ActualFilename),y
                jsr newchrout_t
                iny
                dex
                bne nk
                lda #13
                jsr newchrout_t
                jsr newclrchn_t
no3		ldx ActualLogical
		jsr newchkin_t
		bcs ee
		ldx #0
di		jsr newgetin_t
		sta man_errchannel,x
		inx
		bmi uy
		lda Status
		beq di
uy
		jsr newclrchn_t
                lda man_redirect
                beq no2
                rts
no2		lda ActualLogical
		jmp newclose_t
		.pend
;---------------------------
; Set basic error msg from accu
;
basic_error	.proc
		bcc tul
		sta cfg_8
		asl
                tay
                lda $a326,y
                sta $ae
                lda $a327,y
                sta $af
                ldy #0
lp              lda ($ae),y
                cmp #$80
                and #$7f
                sta man_errchannel,y
                iny
                bmi tul
                bcc lp
                lda #13
                sta man_errchannel,y
tul     	sta cfg_16
                rts
		.pend
;---------------------------
; Show error channel C=0 on error
;
showerror	.proc
		lda man_errchannel
                and #$fe
		cmp #"0"		;0/1
		beq v			;no error

		jsr savedrawwin
                .word $593
		.byte 33,5
		.word txtdev

		ldx #0
                ldy #0
u		stx m_p1
		ldx man_errchannel,y
		cpx #13
		beq u2
                lda cconv,x
                beq jk
                .enc screen
                cmp #"z"+1
                .enc none
                bcs jk
                eor #$c0
		eor m_d018
jk		eor #$80
                ldx m_p1
		sta $60c,x
                inx
		iny
                cpy #64
                beq u2
		cpy #32
		bne u
                ldx #40
                gne u

u2
		jsr waitkey_restorewin
                dec 198
                clc

v		rts

txtdev		.byte 13,2,9,"device"," "+128,"error",13,1,0
		.pend
;---------------------------
; Do partition change
;
changepart	.proc
                lda #"c"
                sta man_input
                lda #"P"
                sta man_input+1
                lda #3
                jsr setnameinput
		jsr read_errchannel.inn
                #jmps showerror
                .pend
;---------------------------
; Change panel (If C=0 then error)
;
changepanelforce .proc
		sec
		.byte SKIP1
changepanel	.proc
		clc
		lda selectedwin+1
                tay
                jsr updateselectedwin
                tax
		lda man_drive,y
		sta ActualDev
                lda man_floppy,y
                bne masdrive	;Floppy, can't do anything
                bcs force
                lda ActualDev
                eor man_drive,x
		bne masdrive    ;different drives, nothing to do
                
                lda man_partition,y
                eor man_partition,x
                beq np		;same partition, no partition select

force		php
                ldx man_partition,y
                stx man_input+2
                inx
                beq illegal	;partition dir
                jsr changepart
                bcs illegal	;ok
                plp
		clc
err             rts		;error

illegal         plp
                bcc masdrive	;different partition, no directory change!
                gcs forc

np		jsr same_dir
		beq masdrive	;in same dir on same partiton

forc		lda selectedwin
                clc
                adc #>man_relpath
                sta ActualFilename+1
                lda #<man_relpath
                sta ActualFilename

                ldy #0
vm              lda (ActualFilename),y
                beq kf
                cmp #":"
                beq kf
                iny
                bne vm
kf		sty ActualFNLength

                jsr read_errchannel.inn
                jsr showerror
                bcc err
masdrive	sec
		rts

changepanel2    .proc
		lda $d011
		bpl *-3
		jsr winselcolupdate
                jsr topdir
;---------------------------
; Move fileselection
;
placebar	.proc
		ldx selectedwin
		lda man_bar,x
		cpx #0
		beq i
		adc #12-1
i
		asl
		asl
		asl
		adc #66

;---------------------------
; Set file selector sprite position
;
bary		.proc
		ldx #9
ni		sta $d000,x
                dex
                dex
                bpl ni
		rts
		.pend

;---------------------------
; Set color of panels
;
winselcolupdate	.proc
		lda #<$d828
		ldy #>$d828
		ldx selectedwin+1
		jsr draw

		lda #<$da08
		ldy #>$da08
		ldx selectedwin

draw		sta m_p1
		sty m_p1+1
		lda manager_inactwincolor,x
		ldy #39
lp		sta (m_p1),y
		dey
		bpl lp

		ldy #68
		ldx #11
lp2		sta (m_p1),y
		pha
		tya
		clc
		adc #40
		tay
		pla
		bcc *+4
		inc m_p1+1
		dex
		bne lp2
		rts
		.pend
;---------------------------
; Print panel statistics
;
man_printstat	.proc
		ldy selectedwin
                lda posl,y
		sta m_p2
                lda posh,y
		sta m_p2+1
                lda #8
                sta m_p1

		ldx man_block_l,y
		lda man_block_m,y
		pha
		lda man_block_h,y
		tay
		pla
		jsr num

		jsr man_printfullfree

		ldy selectedwin
		ldx man_filessel_l,y
		lda man_filessel_h,y
		jsr num2
		ldx man_fulllo,y
		lda man_fullhi,y
		jsr num2
                lda #3
                sta m_p1
		ldx man_drive,y
                jsr num3
		ldx man_partition,y
                lda m_p2
                sec
                sbc #74
                sta m_p2
num3		#lda0
num2		ldy #0
num		jsr numtoasc24
		lda #32
iy		cpy m_p1
		bcs iy2p
		sta (m_p2),y
		iny
		gne iy
iy2p
		lda m_p2
		adc #80-1
		sta m_p2
		bcc *+4
		inc m_p2+1
                ldy selectedwin
		rts

posl    	.byte <$4bf
		.byte <$69f
posh            .byte >$4bf
		.byte >$69f
		.pend
;---------------------------
; Get parameter
;
getparm		.proc
		inc m_p1
		bne *+4
		inc m_p1+1
		lda (m_p1),y
		rts
		.pend
;---------------------------
; Restore a window
;
; .word screen_position
; .byte width-1, height-1
;
waitkey_restorewin .proc
		#stz_a 198
                lda 198
                beq *-2
                
restorewin	.proc
		lda $d011
		bpl *-3
                lda man_savedwind
                sec
                sbc #6
                sta man_savedwind
                clc
		adc #<(man_savedwin-5)
                sta m_p1
                #lda0
                tay
                adc #>(man_savedwin-5)
                sta m_p1+1
                jsr savewin.wp
		lda #1
		gne savewin.in
;---------------------------
; Save a window
;
; .word screen_position
; .byte width-1, height-1
;
savedrawwin    	.proc
		sec
                .byte SKIP1
;---------------------------
; Save a window
;
; .word screen_position
; .byte width-1, height-1
;
savewin		.proc
		clc
		#plx_a
		stx m_p1
		pla
		sta m_p1+1
                bcc x
                pha
                #phx_a
x
		ldy #4
                ldx man_savedwind
fwf		lda (m_p1),y
                dex
                sta man_savedwin,x
		dey
                bne fwf

		php
		jsr wp
                plp
                bcs x2

		#psz m_p1
x2
		php
		#lda0
                jsr in
                #ldatax man_savedwind
                clc
                adc #6
                sta man_savedwind
		lda m_p1
		sta man_savedwin,x
		lda m_p1+1
		sta man_savedwin+1,x
                plp
                bcs drawwin
                rts
                
in		sta m_ascii+2
		ldx man_savedwind
		lda man_savedwin-6,x
		sta m_p1
		lda man_savedwin-5,x
		sta m_p1+1

lp		ldx m_ascii
		ldy m_ascii+2
		beq fy
		dey
fy2		lda (m_p1),y
		sta (m_p3),y
                jsr getparm
;		inc m_p1
;		bne *+4
;		inc m_p1+1
;		lda (m_p1),y
		sta (m_p4),y
		iny
		dex
		bpl fy2
		gmi rf

fy		lda (m_p3),y
		sta (m_p1),y
                jsr getparm
;       	inc m_p1
;       	bne *+4
;       	inc m_p1+1
		lda (m_p4),y
		sta (m_p1),y
		iny
		dex
		bpl fy

rf		tya
		clc
		adc m_p1
		sta m_p1
		bcc djx
                clc
		inc m_p1+1
djx
		lda m_p3
		adc #40
		sta m_p3
		sta m_p4
		bcc *+6
		inc m_p3+1
		inc m_p4+1

		dec m_ascii+1
		bpl lp
		rts

wp		jsr getparm
		sta m_p3
		sta m_p4
		jsr getparm
		sta m_p3+1
		eor #$d8^$04
		sta m_p4+1
		jsr getparm
		sta m_ascii
		jsr getparm
		sta m_ascii+1
                rts
		.pend
;---------------------------
; Draw a window
;
; .word screen_position		($00xx mean it's in X/Y)
; .byte width-1, height-1
; .word text_in_memory
;
drawwin_nowait	.proc
		sec
		.byte SKIP1
drawwin       	.proc
		clc
		pla
		sta m_p1
		pla
		sta m_p1+1
                sty m_p4+1

		ldy #0
                jsr getparm
                sta m_p4
                jsr getparm
                bne vd2
                stx m_p4
                .byte SKIP2
vd2             sta m_p4+1
		jsr getparm
		sta m_ascii
		jsr getparm
		sta m_ascii+1
		jsr getparm
		sta m_p3
		jsr getparm
		sta m_p3+1

		#psz m_p1

		lda m_p4
		sta m_p1
		sta m_p2
		lda m_p4+1
		sta m_p1+1
		eor #$d8^$04
		sta m_p2+1

		ldx manager_win_color

		.if DECORATION=1
		lda #248
		sta m_ascii+2
		ldy #108
		lda #123
                .else
		lda #64+128
		sta m_ascii+2
		ldy #112+128
		lda #110+128
                .fi

		bcs now 	;faster copy window draw
		bit $d011
		bpl *-3
now
		jsr windrln

lp		lda m_p1
		clc
		adc #40
		sta m_p1
		sta m_p2
		bcc ni
		inc m_p1+1
		inc m_p2+1
ni
		dec m_ascii+1
		beq ki

		lda #32+128
		sta m_ascii+2
                .if DECORATION=1
                ldy #244;245
                lda #234;246
                .else
		lda #93+128
                tay
                .fi
		jsr windrln
		#jmps lp
ki
		.if DECORATION=1
		lda #249
		sta m_ascii+2
		ldy #124
		lda #126
                .else
		lda #64+128
		sta m_ascii+2
		ldy #109+128
		lda #125+128
                .fi
		jsr windrln

drawtext	.proc
fr2		ldy #0
fr		lda (m_p3),y
		bmi ok
		beq vege
		cmp #13
		bne o1
rp		tya
		adc m_p3
		sta m_p3
		bcc *+4
		inc m_p3+1
		lda m_p4
		clc
		adc #40
		sta m_p4
		bcc fr2
		inc m_p4+1
		gcs fr2

o1		cmp #29
		beq oo
                cmp #2
                bne vd
                iny
                lda (m_p3),y
                sta m_p1
                lda m_p3
                sbc m_p1
                sta m_p3
                bcs *+4
                dec m_p3+1
                tya
                sec
                adc m_p1
                tay
                bne fr

vd		cmp #1
		bne okk
		tya
		clc
		adc m_p4
		sta m_p1
		sta m_p2
                #lda0
		adc m_p4+1
		sta m_p1+1
		eor #$d8^$04
		sta m_p2+1

		#phy_a
                .if DECORATION=1
		lda #247;64+128
		sta m_ascii+2
		ldy #244;245
		lda #234;246
                .else
		lda #64+128
		sta m_ascii+2
		ldy #107+128
		lda #115+128
                .fi
		jsr windrln
		#ply_a
		sec
		gcs rp

okk		eor m_d018
ok		sta (m_p4),y
oo		iny
		bne fr
vege		rts
		.pend
;---------------------------
; Draw 1 line of window
;
windrln		.proc
		sty m_ascii+3
		ldy m_ascii
		sta (m_p1),y
		txa
		sta (m_p2),y
		dey
dy		lda m_ascii+2
		sta (m_p1),y
		txa
		sta (m_p2),y
		dey
		bne dy
		lda m_ascii+3
		sta (m_p1),y
		txa
		sta (m_p2),y
		rts
		.pend
;---------------------------
; Draw panel
;
redrwincap	.proc
		ldx selectedwin
                lda posl,x
                ldy posh,x
		sta m_p4
		sty m_p4+1
                clc
                adc #231
                sta m_p2
                bcc *+3
                iny
                sty m_p2+1

		ldy #68
		ldx #10
		lda #30+128
lp2		sta (m_p4),y
		tya
		clc
		adc #40
		tay
		bcc *+4
		inc m_p4+1
		lda #93+128
		dex
		bne lp2
		lda #113+128
		sta (m_p4),y
                dec m_p4+1
                
                ldx #winbar2-winbar
                #stz_a m_p3
		ldy #39
lp3		lda m_p3
		bne ti
                dex
		lda winbar,x
                bmi dsc
                cmp #32
                bcs sc
                sta m_p3
ti              dec m_p3
		lda (m_p4),y
                ora #128
                gmi dsc
sc              eor m_d018
dsc		sta (m_p4),y
		dey
		bpl lp3
                
                asl m_d018
                lsr m_d018

                lda #<winbar2
                sta m_p3
                lda #>winbar2
                sta m_p3+1
		jsr drawtext
                asl m_d018
                sec
                ror m_d018
                #jmps man_printfullfree
                
posl		.byte <$0428
		.byte <$0608
posh		.byte >$0428
		.byte >$0608

winbar		.byte " "+128,"device",":"+128
		.byte 8," "+128
		.byte "label",":"+128
		.byte 16," "+128
winbar2         .byte 13,13,2,28,"blocks"
		.byte 13,13,2,28,"files"
                .byte 13,13
		.byte 13,13,2,28,"drive part",0
		.pend
;---------------------------
; main copy
;
COPY_E_INPUT	= 15
COPY_E_OUTPUT	= 16
COPY_INPUT	= 17
COPY_OUTPUT	= 18

main_copy	.proc
		jsr no_files_or_partlist_or_virtual
		bne *+3			;empty panel?
		rts

		#stz_a man_overwrite	;no overwrite
		#stz_aa man_enterall 	;no direnter
                #stz_aa man_recurs_mode	;copy mode
                #stz_aa man_abort	;no abort

                ldy selectedwin+1
                lda #COPY_E_OUTPUT
		jsr open_error		;open error channels
                ldy selectedwin
                lda #COPY_E_INPUT
		jsr open_error

                ldx selectedwin
		lda man_filessel_l,x
		ora man_filessel_h,x
		beq copycurrent

re              jsr savewin		;directory copy
		.word $543
		.byte 33,10

		lda selectedwin+1
                jsr rel_path_m_p1.in
                jsr rel_path_m_p1s.in
                sty man_recurs_len
                
                tsx
                stx man_recurs_sp

		#stz_a man_multi
		#stz_aa man_multi+1

lp		ldy selectedwin
		#ldatax man_multi
		cmp man_files_l,y
		lda man_multi+1
		sbc man_files_h,y
		bcs ss2
		lda man_multi+1
                lsr
		txa
		jsr calc_filepos
                #lda0
		jsr man_sel
		bpl k
                jsr processfilename
                bcc k
		jsr man_toggle_sel
                #stz_a man_recurs

                jsr man_dir
                bpl reg
                jsr copyd
                #jmps tu

reg             jsr copyf
tu              jsr changepanelin

                jsr check_abort
                bne ss2

k		inc man_multi
		bne lp
		inc man_multi+1
		gne lp

ss2		jsr restorewin
		jsr printdirandstat
		jsr changepanelout
		#jmps ss
;-------------------
;Copy current file
;
copycurrent    	jsr calc_filepos_cursor
		jsr processfilename
                bcc ce
                jsr man_dir
                bpl li
		jsr man_toggle_sel	;mark selected
		#jmps re		;directory copy
li
		jsr savedrawwin
                .word $571
		.byte 21,8
		.word txtcopy

		ldy #19
ndu		ldx man_input,y
		bne *+4
		ldx #32
		lda cconv,x
		sta $612,y
                lda manager_input_color
                sta $da12,y
		dey
		bpl ndu

		ldx #<$68a
		ldy #>$68a
		lda #20
		jsr input
                pha
		jsr restorewin
		pla
                cmp #3
                beq ce
                
                jsr savewin
		.word $543
		.byte 33,10

                jsr copyf
                jsr restorewin

ss		jsr close_error
		jsr modifieddir
                jmp changepanel

ce		jsr close_error
		#jmps setdev

changepanelout	lda #COPY_E_OUTPUT
		.byte SKIP2
changepanelin	lda #COPY_E_INPUT
		sta man_redirect
		jmp changepanel

close_error	#stz_a man_redirect
		lda #COPY_E_INPUT
		jsr newclose_t
		lda #COPY_E_OUTPUT
		jmp newclose_t

txtcopy		.byte 13,2,7,"copy",13,1
		.byte 29,"from",":"+128,13,13,13
		.byte 29,"to",":"+128,0
                
open_error      ldx man_drive,y
                ldy #15
                jsr $ffba
                #stz_a ActualFNLength
                jmp newopen_t
                
		.pend
;-------------------------------------------
;Copy a dir (recursive)
;
copyd		.proc
		ldx #3
                jsr man_copyfname3
                ldy #0
		jsr processfilename.in2

		lda man_recurs_mode
                beq copy

                ldy #20
nou2    	cpy #17
		bcs tp
		ldx man_input+2,y
	       	bne *+4
tp	       	ldx #32
	       	lda cconv,x
	        eor #128
        	sta $611,y
	       	dey
	       	bne nou2
                geq nocopy1

copy	  	jsr drawwin_nowait
                .word $543
		.byte 33,10
		.word copyf.txtcopy2

		ldy #20
ndu2    	cpy #17
		bcs tp2
		ldx $203,y
		bne *+4
tp2		ldx #32
		lda cconv,x
                eor #128
		sta $5c3,y
		sta $613,y
		dey
		bne ndu2

                jsr main_copy.changepanelout  	;target panel

                jsr mkdir		;try to make dir
                jsr err_is_exists
                beq kku
                jsr showerror
                bcs nne
skipdirx        rts			;jmp skipdir

kku		lda man_enterall	;dir exists
		cmp #"s"
                beq skipdirx
                cmp #"a"
		beq nne

		jsr savedrawwin
                .word $571
		.byte 21,8
                .word txtexists

		ldy #3
ndu		ldx $201,y
		cpy $200
		bcs xe
		lda cconv,x
                eor #$80
		sta $5ea-3,y
		iny
                cpy #19
		bcc ndu
xe
                jsr waitkey_restorewin

		jsr $f142
                cmp #"s"
                bne bb
                sta man_enterall
                lda #"n"
bb              cmp #"a"
                bne tnu
                sta man_enterall
                lda #"y"
tnu             cmp #"y"
                bne skipdirx


nne             jsr chdir		;enter target dir
                bcc skipdirx

		jsr append_actualfn_plus3_to_path

                jsr main_copy.changepanelin		;change to source panel

nocopy1
		jsr chdir		;enter source directory
                bcc skipdir2

		jsr append_actualfn_plus3_to_path
                jsr topdir

		lda man_recurs_mode
                bne nb			;not copy
                
                jsr same_part
                bne nb			;not the same partition

                jsr rel_path_m_p1
                sta m_p2+1
                sty m_p2		;source
                lda selectedwin+1
                jsr rel_path_m_p1.in	;dest

		ldy #0
llk             lda (m_p2),y
                cmp (m_p1),y
                bne jo
                tax
                beq bajx
                iny
                gne llk
jo		
		tax
                bne nb
                cpy man_recurs_len
                bcc nb
bajx		#jmps baj

nb		inc man_recurs

		lda man_recurs
                ldx ActualDev
                tay
                iny
                jsr $ffba
                lda #1
                ldx #<$ffd0
                ldy #>$ffd0
                jsr $ffbd
                jsr newopen_t	;open new source directory
                jsr basic_error
                bcs tu
                jsr read_errchannel
tu              jsr showerror
		bcc skipd3

                ldx man_recurs
                #stz_a man_dirpos,x
                jsr newchkin_t
                jsr basic_error
                bcs tu
                
                jsr newgetin_t  ;skip dirlabel
                eor #"i"
                sta man_nonide64rec
                beq xm
                ldx #221
nu              jsr newgetin_t
                dex
                bne nu

xm              jsr readline    

loop            ldx man_recurs	;directory read loop
                jsr newchkin_t
                jsr basic_error
                bcs tu

                ldx man_recurs
                lda man_dirpos,x
                inc man_dirpos,x
		ldx man_nonide64rec
                beq twx
                and #7
                bne twx
                ldx #226
                .byte SKIP2
twx		ldx #224
		jsr readline2

                jsr newclrchn_t
                lda Status
                beq ok
skipd3          #jmps skipdir3	;end of dir                

ok              lda man_nonide64rec
		beq joi
                lda $206
                pha
                lda $222
                sta $206
                lda $223
                sta $207
                ldx #16
xt              dex
		beq kq
		lda $209,x
                cmp #$a0
                beq xt
kq		#stz_a $20a,x
                lda #6
                sta m_p1
                lda #2
                sta m_p1+1
                pla
                and #%10001111
                cmp #$81
		bcc kek
                cmp #$87
                bcs kek
                tax
                ldy #2
cek             lda typ-$81,x
                sta $21b,y
                .if SUPERCPU=1
                txa
                adc #6
                tax
                .else
                lda #$ff
                sbx #256-6
                .fi
                dey
                bpl cek

		cpx #$86+18
                beq thisd
                gne thisnd

typ             .text "qgrlmr"
                .text "ersebi"
                .text "spurcd"
                
joi		lda #255
		clc
		adc $214
                #lda0
                adc $215
                tax
                #lda0
                adc $216
                tay
                #lda0
                adc $217
                beq *+6
                ldx #255
                ldy #255
                stx $201
                sty $202
                ldx #0    ;0123456789012345678901
                stx $214  ;LH"1234567890123456" PRG
                inx
		stx m_p1
		inx
                stx m_p1+1
le              lda $21d,x
		bne *+4
                lda #32
                sta $216,x
                dex
                bpl le

                lda $21c
                and #FTYPE_MASK|FATTR_CLOSED
                cmp #FTYPE_DIR|FATTR_CLOSED
                bne nio
thisd           jsr ispp
                beq loopx
                sec
                jsr ispp.point
loopx           beq loop
                jsr copyd
                #jmps ir

nio		cmp #FTYPE_NORMAL|FATTR_CLOSED
		bne kek
thisnd		ldy #0
		lda (m_p1),y
                pha
                iny
		lda (m_p1),y
                pha
		jsr man_copyfname
                #plx_a
                pla
                ldy #0
		jsr processfilename.in2
		jsr copyf
ir              lda man_recurs_mode
                bne kek
                jsr main_copy.changepanelin		;change to source panel

kek             jsr check_abort
                beq loopx

skipdir3	jsr newclrchn_t		;end of directory
		lda man_recurs
		jsr newclose_t		;close dir
                dec man_recurs
		jsr pont		;go into parent dir
                bcc exit
                
baj             jsr remove_last_path_part

		sec
skipdir2       	lda man_recurs_mode
                beq skipdir2x		;it's copy
                bcc skipdir		;could not cd, then no remove
                stx man_input+3
                ldx #255
n	        inx
                iny
                lda (m_p1),y
                sta man_input+4,x
                bne n
                sta man_input+3,x
		jsr topdir
                ldy #I_RD
                jsr putandexecinput
                jmp showerror

skipdir2x      	jsr topdir		;display dirname after leave
                jsr main_copy.changepanelout     	;enter destination panel

                jsr pont		;go into parent
                bcc exit
                
                jsr remove_last_path_part

skipdir		rts

exit		ldx man_recurs_sp	;not recoverable error
		inx
                inx
                txs
                jsr newclall_t
                jmp manager.redraw

readline        ldx #224
readline2       jsr newgetin_t
		sta $204-224,x
                inx
                bne readline2
                rts

pont            ldx #3
                stx $200
                ldx #$5f
                .byte SKIP2
chdir           ldx #":"
		lda #"c"
                jsr chdu
		jmp showerror

mkdir           ldx #":"
		lda #"m"
chdu    	sta $201
                lda #"d"
                sta $202
		stx $203
                jsr setname200
		jmp read_errchannel.inn

txtexists       .byte 13,2,4,"dir exists",13,1
		.byte 13,13,2,6,"enter","?"+128,13,13
		.byte 29,"yes","/"+128,"no","/"+128,"all","/"+128,"skip",160,"all","!"+128,0
		.pend
;-------------------------------------------
;Copy a file
;
copyf           .proc
		lda man_recurs_mode
                beq copy

                ldy #20
ndu2u    	ldx $201-1,y
	       	bne *+4
	       	ldx #32
	       	lda cconv,x
	        eor #128
        	sta $611,y
	       	dey
	       	bne ndu2u

                ldy #0
ndqu2    	iny
		lda $200,y
                cmp #","
                bne *+4
                lda #"="
		sta man_input+1,y
                tax
		bne ndqu2

		ldy #I_S
                jsr putandexecinput
                jmp showerror

copy		jsr drawwin_nowait
                .word $543
		.byte 33,10
		.word txtcopy2			;big copy window

		ldy #20
ndu2    	ldx $200,y
		bne *+4
		ldx #32
		lda cconv,x
                eor #128
		sta $5c3,y
		ldx man_input-1,y
		bne *+4
		ldx #32
		lda cconv,x
                eor #128
		sta $613,y
		dey
		bne ndu2

                lda #COPY_INPUT
		ldx ActualDev
;                ldy #0
                jsr $ffba
                lda ActualFNLength
                jsr setname201

                jsr newopen_t		;open source file
                jsr basic_error
                bcs xdx

		ldx #0
vsd		lda man_input,x
                beq kv
                sta $201,x
                inx
                cpx #20
                bne vsd
kv		stx $200

		lda #COPY_E_INPUT
                sta man_redirect
                jsr read_errchannel
xdx		jsr showerror
                php

                jsr main_copy.changepanelout;change to destination panel
                plp
                bcc skipfile2	  	;file open error

		lda man_overwrite
                cmp #"a"
                beq ye

                lda #COPY_OUTPUT
                ldx ActualDev
                ldy #1
                jsr $ffba

                jsr setname200

                jsr newopen_t		;open destination file
                jsr basic_error
                bcs noexists

                jsr read_errchannel
                jsr err_is_exists
                bne noexists

		lda man_overwrite
                cmp #"s"
                beq skipfilex

		jsr savedrawwin
                .word $571
		.byte 21,8
		.word txtexists
                
		ldy #19
ndu		ldx $201,y
		cpy $200
		bcc *+4
		ldx #32
		lda cconv,x
                eor #$80
		sta $5ea,y
		dey
		bpl ndu

		jsr waitkey_restorewin

		jsr $f142
                cmp #"s"
                bne bb
                sta man_overwrite
                lda #"n"
bb              cmp #"a"
                bne xn
                sta man_overwrite
                lda #"y"
xn		cmp #"y"
                beq nnk
skipfilex       jmp skipfile

nnk             lda #COPY_OUTPUT
                jsr newclose_t

ye              ldx $200
bg              lda $201,x
                sta $204,x
                dex
                bpl bg
                ldx #2
li              lda rew,x
                sta $201,x
                dex
                bpl li

                lda #COPY_OUTPUT
                ldx ActualDev
                ldy #1
                jsr $ffba

		lda $200
                clc
                adc #3
                jsr setname201

                jsr newopen_t
                jsr basic_error
                bcs noexists
                jsr read_errchannel

noexists        jsr showerror
		bcc skipfilex
                
                lda #64
                #sta_cfg_open
                sta manager_chkin_exp	;IDE64
                sta manager_chkout_exp	;IDE64
                #sta_cfg_16

		jsr selectoutput
		jsr selectinput

		ldx selectedwin
                ldy dirm,x
                iny
                sty m_p1+1
                #stz_a m_p1
                #stz_aa m_p3
                #stz_aa m_p3+1
                #stz_aa m_p4
                #stz_aa man_copybar+3
		#stz_aa m_p5
		#stz_aa m_p5+1
                #stz_aa m_p4+1
                #stz_aa man_offs
                lda #<$664
                sta m_p2
                lda #>$664
                sta m_p2+1

                ldx #31
cx		lda man_dirmem2,x
                sta man_temp,x
                dex
                bpl cx
                #sta_cfg_open
                #ldx_l_a manager_chkin_exp
                stx man_fast
                lda manager_chkout_exp
                sta man_fast2
                #sta_cfg_16
                beq re2		;destination serial!
;---
                txa
                bne bigcopyloop  	;source not serial!

                jsr man_fastload_init
                #jmps csc2
;---
re2		txa
                beq bigcopyloop          ;source serial!

		jsr newclrchn_t
                jsr man_fastsave_init

csc2            jsr selectoutput2
		jsr selectinput2

bigcopyloop     lda m_p1+1
                sta m_ascii+2
                bit man_fast	;fastload?
		bpl old
                jsr man_fastload
                #tyx_a
                lda m_p1+1
                sec
                sbc m_ascii+2
                tay
                #jmps kb2

old		ldx #0
                ldy #64
		lda man_fast2   ;fastsave?
                bpl tiu
                stx m_p1
                ldx #<8128
                ldy #>8128
tiu             jsr sizeeor
		bvc seri	;ide64?
		lda #m_p1
                sei
                jsr newread_t
                cli
                bcc mv
                jsr selectoutput2
seri            jsr selectinput2
                lda man_offs
                tay
                clc
                adc m_ascii
                sta m_ascii
                bcc vf
                inc m_ascii+1
vf              #stz_a man_offs
nvx             inc m_ascii
		beq v1
vm		jsr newchrin_t
                sta (m_p1),y
                lda Status
                bne jo
                iny
                bne nvx
                jsr man_showbar1
                inc m_p1+1
                gne nvx

v1              inc m_ascii+1
                bne vm
kb
                #tyx_a
                ldy #0
kb2             jsr man_showbar
                lda m_p1+1
                sec
                sbc m_ascii+2
                tay
                lda m_ascii+2
                sta m_p1+1
                gne mvj

jo              cmp #$42
		beq kb
                iny
                bne kb
                inc m_p1+1
                gne kb

mv		jsr man_showbar

mvj		lda Status
                pha

		jsr sizeeor

		bit man_fast2	;fastsave?
                bpl old2
                jsr man_fastsave
                #tyx_a
                lda m_p1+1
                sec
                sbc m_ascii+2
                tay
                #jmps hd
                
old2            bvc seri2	;ide64?
                lda #m_p1
                sei
                jsr newwrite_t
                cli
                bcc mv2
                jsr selectinput2
seri2           jsr selectoutput2
                lda m_p1+1
                sta m_ascii+2
                ldy #0
                jsr copy_upper

		#tyx_a
                ldy #0
hd              jsr man_showbar
                lda m_p1+1
                sec
                sbc m_ascii+2
                tay
                lda m_ascii+2
                sta m_p1+1
                gne mv2j

mv2             jsr man_showbar
mv2j		lda Status
                bne baj
                tya
                clc
                adc m_p3
                sta m_p3
                bcc vxs
                inc m_p3+1
                bne vxs
                inc m_p4
vxs
                tax
		lda m_p3+1
                ldy m_p4
		jsr numtoasc24

                pla
                beq bigcopyloop
                .byte SKIP1
baj		pla

baj2		ldx #31
cx2		lda man_temp,x
                sta man_dirmem2,x
                dex
                bpl cx2

skipfile3      	jsr newclrchn_t
skipfile        lda #COPY_OUTPUT
                jsr newclose_t
		lda #COPY_E_OUTPUT
                jsr redir_showerror
                
skipfile2      	lda #COPY_INPUT
                jsr newclose_t
		lda #COPY_E_INPUT
                jmp redir_showerror

sizeeor		txa
                eor #$ff
                sta m_ascii
                tya
                eor #$ff
                sta m_ascii+1
nin             rts
;-----------------------
;Redirect and show error
;
redir_showerror sta man_redirect
                jsr read_errchannel
                #jmps showerror
;-----------------------
;Select input/output, if error then abort
;
selectoutput2	lda man_fast2
		bmi nin
selectoutput    ldx #COPY_OUTPUT
                jsr newchkout_t
                #jmps at
selectinput2	lda man_fast
		bmi nin
selectinput     ldx #COPY_INPUT
                jsr newchkin_t
at              jsr basic_error
                jsr showerror
                bcs nin
                pla
                pla
                gcc skipfile3

rew		.text "@0:"
txtcopy2       	.byte 13,2,11,"copying",13,1
		.byte 29,"from",":"+128,13,13
		.byte 29,"to",":"+128,13,13
		.byte 29,"blocks",":"+128,160,"0"+128,0
                
txtexists       .byte 13,2,4,"file exists",13,1
		.byte 13,13,2,4,"overwrite","?"+128,13,13
		.byte 29,"yes","/"+128,"no","/"+128,"all","/"+128,"skip",160,"all","!"+128,0
                .pend
                
err_is_exists   .proc
		lda man_errchannel
                cmp #"6"
                bne noexists
                lda man_errchannel+1
                cmp #"3"
noexists	rts
		.pend

check_abort     .proc
		jsr $f142
                beq nos
                cmp #3
                bne nos

re		jsr savedrawwin
                .word $59f
		.byte 9,6
                .word txtabort
                jsr waitkey_restorewin
                
                jsr $f142
                cmp #3
                beq re
		cmp #"y"
                bne nos
                sta man_abort
nos		lda man_abort
		rts

txtabort        .byte 13,13,29,29,"abort","?"+128,13,13
		.byte 29,29,"yes","/"+128,"no",0
                
		.pend
;---------------------------
; process filename for copy/delete
;
; C=0 on error
;
processfilename	.proc
		lda m_p1+1
                cmp #>man_dirmem1
                bcc err

		jsr man_copyfname
		ldy #1
                #ldatax (m_p1),y
                dey
                lda (m_p1),y
in2             asl
                sta man_copybar
                txa
                rol
                sta man_copybar+1
                lda #0
                rol
                sta man_copybar+2
nd		lda (ActualFilename),y
		cpy ActualFNLength
		bcc vf
		#lda0
                sta (ActualFilename),y
vf		sta man_input,y
		iny
		cpy #20
		bne nd
err             rts
		.pend
;---------------------------
; main mkdir
;
main_mkdir	.proc
                lda man_parlist,x
                lsr
                ora man_virtual,x
                bne xjx                

		jsr savedrawwin
                .word $59b
		.byte 17,4
		.word txtmkdir

		ldx #<$614
		ldy #>$614
		lda #16
		jsr clrinput
		cmp #3			;stop?
		beq xji

		ldx #16
ul		lda man_input,x
		sta man_input+3,x
                sta man_jumpon,x
		lda mdtxt,x
		sta man_input,x
		dex
		bpl ul
                jsr jumptypedir

		jsr do_errchannel
                jsr showerror

		clc
xji	        php
		jsr restorewin
                plp
                bcs xjx
		#jmps modifieddir

xjx		rts

mdtxt		.text "md:"
txtmkdir	.byte 13,29,29,"make"," "+128
		.pend
dirtype		.byte "directory",13,1,0

jumptypedir	.proc
                ldx #3
np              lda dirtype-1,x
                sta man_jumpontype-1,x
                dex
                bne np
                rts
		.pend
;---------------------------
; main delete
;
main_delete	.proc
		jsr no_files_or_partlist_or_virtual
		bne *+3
		rts		;exit

		lda man_filessel_l,x
		ora man_filessel_h,x
		bne ncurrent

	  	jsr calc_filepos_cursor
		jsr man_toggle_sel
ncurrent
                lda #"n"
                sta 631
                sta man_recurs_mode	;remove mode

                ldy selectedwin
                lda #COPY_E_INPUT
		jsr main_copy.open_error
		lda #COPY_E_INPUT
                sta man_redirect

		jsr savedrawwin
                .word $599
		.byte 21,4
		.word txtdelete2

		#stz_a man_multi
		#stz_aa man_multi+1

lp		ldy selectedwin
		#ldatax man_multi
		cmp man_files_l,y
		lda man_multi+1
		sbc man_files_h,y
		bcs ss2
		lda man_multi+1
                lsr
		txa
		jsr calc_filepos
                #lda0
		jsr man_sel
		bpl k
                jsr man_dir
                sta m_p5
                jsr processfilename
                bcc k
		jsr man_toggle_sel

                lda 631
                ldx #0
                stx 198
                cmp #"a"
                beq all

		#psz m_p1

		jsr savedrawwin
                .word $571
		.byte 21,6
		.word txtdelete

		ldy #19
ndu		ldx man_input,y
		bne *+4
		ldx #32
		lda cconv,x
                eor #$80
		sta $5ea,y
		dey
		bpl ndu

		jsr waitkey_restorewin

		pla
                sta m_p1
                pla
                sta m_p1+1

		jsr $f142
                sta 631
                cmp #"y"
                beq all
                cmp #"a"
                beq all
                cmp #3
                bne no
                
ss2		jsr restorewin
		jsr main_copy.close_error
		#jmps modifieddir

all
		#stz_a man_recurs
                #stz_aa man_abort

		ldy m_p5
                bpl fil
                jsr copyd
                #jmps no
fil             jsr copyf

no
		lda man_abort
                bne ss2
k		inc man_multi
		bne lp
		inc man_multi+1
		gne lp

txtdelete      	.byte 13,2,6,"delete",13,1,13,13
		.byte 2,4,"yes","/"+128,"no","/"+128,"all",0

txtdelete2     	.byte 13,2,5,"deleting",13,1,0
		.pend
;---------------------------
; main rename
;
main_rename	.proc
		jsr no_files_or_partlist_or_virtual
		bne *+3
err             rts

	    	jsr calc_filepos_cursor
		jsr processfilename
                bcc err

		jsr savedrawwin
                .word $571
		.byte 21,8
		.word txtrename

                #stz_a $200+20
		ldy #19
ndu		lda man_input,y
		sta $200,y
		tax
		bne *+4
		ldx #32
		lda cconv,x
		sta $612,y
                lda manager_input_color
                sta $da12,y
		dey
		bpl ndu

		ldx #<$68a
		ldy #>$68a
		lda #20
		jsr input
		cmp #3			;stop?
		beq xji

		ldx #20
                #lda0
                beq kj
ul		lda man_input,x
kj		sta man_input+2,x
		lda rntxt,x
		sta man_input,x
		dex
		bpl ul
                
;                ldx #255
                lda #","
nu              inx
		cmp $200,x
                bne nu
                ldy #0
cc              inx
                lda $200,x
                bne re
                dex
                lda #32
re              sta man_jumpontype,y
                iny
                cpy #3
                bcc cc
                
                ldx #255
pi              inx
		cpx #16
                bcs en2
		lda man_input+2,x
                beq en
                sta man_jumpon,x
                eor #","
                bne pi
en		sta man_jumpon,x
en2

		ldy selectedwin
		lda man_floppy,y
                ora man_cmd,y		;CMD or FLOPPY
                lsr
                bcs nq

		lda man_input+2,x	;no type
                beq nq

                ldy #0
cc2             lda man_input+3,x
                bne knu
                lda #32
                dex
knu             inx
		sta man_jumpontype,y
                iny
                cpy #3
                bcc cc2
		clc

nq              inx
                lda man_input,x
                beq nx
                eor #","
                bne nq
                bcc nq
nx
                lda #"="
                sta man_input,x
                ldy #255
nq2             iny
                inx
                lda $200,y
                sta man_input,x
                beq nx2
                eor #","
                bne nq2
                bcc nq2
                sta man_input,x
nx2

		jsr do_errchannel
                jsr showerror

		clc
xji	        php
		jsr restorewin
                plp
		bcc modifieddir
		rts


rntxt   	.text "r:"
txtrename      	.byte 13,2,6,"rename",13,1
		.byte 29,"from",":"+128,13,13,13
		.byte 29,"to",":"+128,0
		.pend
;---------------------------
man_showbar1	.proc
		#phx_a
                #phy_a
                inc m_p5+1
                bne man_showbar.in
                geq man_showbar.in2

man_showbar	.proc
		txa
                pha
                clc
                adc m_p5
                sta m_p5
                tya
                pha
                adc m_p5+1
                sta m_p5+1
                bcc *+4
in2             inc m_p4+1
in
                sec
xc		lda m_p5
                sbc man_copybar
                tay
		lda m_p5+1
		sbc man_copybar+1
                tax
                lda m_p4+1
                sbc man_copybar+2
                bcc we
                sta m_p4+1
                sty m_p5
                stx m_p5+1
                inc man_copybar+3
                bne xc
                dec man_copybar+3
we
		#ldatax man_copybar+3
                and #7
                tay
                txa
                lsr
                lsr
                lsr
                tax
                lda bar,y
jw              sta $6ac,x
                lda #32
                dex
                bpl jw
                #ply_a
                #plx_a
jooo            rts
bar		.byte 229,244,245,225,118,106,103,32
		.pend
;---------------------------
; reload other panel too if change happend in same dir
;
modifieddir     .proc
		jsr main_reload
                jsr same_dir
                bne man_showbar.jooo
                jsr changepanel
                jsr main_reload2.in
                jmp changepanel
		.pend
;---------------------------
; main command
;
main_command	.proc
                lda man_floppy,x
                beq x

		jsr savedrawwin
                .word $595
		.byte 29,5
		.word txtcmd

		ldx #<$60e
		ldy #>$60e
		lda #28
		jsr clrinput
		cmp #3			;stop?
		php
		beq xji
                
tk		jsr do_errchannel

		clc
xji		php

		jsr restorewin

                plp
                bcs *+5
                jsr showerror

		plp
		bne modifieddir
x		rts

txtcmd		.byte 13,2,7,"disk"," "+128,"command",13,1,0
		.pend
;---------------------------
; Path of current window into m_p1, Y at end of name
;
rel_path_m_p1s 	.proc
		jsr rel_path_m_p1
in              ldy #0
nvfs            lda (m_p1),y
                beq kmv
                iny
                bne nvfs
kmv		rts
		.pend

rel_path_m_p1 	.proc
                lda selectedwin
in              clc
                adc #>man_relpath
                sta m_p1+1
                ldy #<man_relpath
                sty m_p1
                rts
                .pend
;---------------------------
; Handle top menu
;
topmenu       	.proc                
ncs             lda 653
		lsr
                bcs bs 
                lsr
                bcs ncs
                gcc csv

bs		ldx #6
v               lda $d011
                bmi *-3
		lda $d011
                bpl *-3
                dex
                bne v
                lda $d018
                eor #2
                sta $d018
                lda m_d018
                eor #64
                sta m_d018

		lda selectedwin
                pha
                #stz_a selectedwin
                #stz_aa man_oldsc_h
                #stz_aa man_oldsc_h+1
                jsr redrwincap
                jsr scrollbar
		inc selectedwin
                jsr redrwincap
                jsr scrollbar
                pla
                sta selectedwin

nnf	    	lda 653
                cmp #3
                beq bs
                lsr
                lsr
                bcs nnf
                rts

csv		#stz_a $d015

                ldx #15
u               dex
                beq xb
jf              jsr wait_a_bit
                dey
                bne jf
		jsr $f142
		beq u

		jsr $7c
                bcs colkey
		and #$0f
                cmp #8
                bcs n
                adc #10
n               pha
		jsr changepanel
                #ldatax selectedwin+1
                jsr updateselectedwin
		pla
		sta man_drive,x
		sta ActualDev
                lda #1
                sta man_parlist,x
                lsr
                sta man_virtual,x                
                jsr man_cdroot
		jmp main_reload2

colkey      	ldy #9
lpp		cmp key,y
		bne oo
                tya
                adc #8-1
		gcc n
oo		dey
		bpl lpp
xb      	rts			;exit

key		.byte 155,41,95,129,149,150,151,152,153,154
		.pend
;---------------------------
; Display current path on top of screen
;                
topdir		.proc
		lda m_p2
                pha
		
                jsr rel_path_m_p1s
                #lda0
                cpy #44
                bcc prin
                tya
                sbc #43
prin    	
		#sev g

                sta m_p2
		ldy #3
lp3		lda manager_inactwincolor
                sta $d800-3,y
                bvc kr
		#ldatax (m_p1),y
                bne vm
                clv
kr              ldx #32
vm		lda cconv,x
		eor #$80
		sta $400-3,y
                cpy #21
                bne tp
                lda m_p2
                beq tp
                clc
                adc m_p1
                sta m_p1
                bcc *+4
                inc m_p1+1
                iny
                lda #"="+128
                sta $400-3,y
                sta $401-3,y
                lda manager_inactwincolor
                sta $d800-3,y
                sta $d801-3,y
                iny                
                #sev g
tp              iny
                cpy #43
		bcc lp3

                pla
                sta m_p2
g		rts
		.pend
;---------------------------
; Place selector bar on file
;                
man_jumponfile  .proc
		clc
		ldx selectedwin
		ldy man_jumpon
                bne man_jumponfile2.kell
                iny
                sty m_ascii
                gne man_jumponfile2.x
                
man_jumponfile2 .proc
		sec

kell		lda #2
                sta m_ascii
	        bcs xe

lp		jsr calc_filepos_cursor
                ldy #3
lp2             lda man_jumpon-3,y
                beq jo
                jsr man_get
                bne xe
                iny
                cpy #19
                bcc lp2
jo              ldy #21
lp3             lda man_jumpontype-21,y
                beq ki
                jsr man_get
                bne xej
joo             iny
                cpy #24
                bcc lp3
		gcs ki

xej		cmp #$20^"<"
		bne xe
		lda man_jumpontype-21,y
		cmp #$20
                beq joo

xe		lda man_bar,x
		jsr chk
		bcs x
vv		lda man_bar,x
		cmp #10
		beq o2
		cmp #5
		bcs o1
ui		inc man_bar,x
                gne lp
                
x		jsr gotop
                dec m_ascii
                bne lp
ki		#stz_a man_jumpon
		rts

o1 		beq o3
		lda #10
		jsr chk
                bcs ui
                dec man_bar,x
		inc man_el_l,x
		bne vv
		inc man_el_h,x
                gne vv
                
o3		lda #10
		jsr chk
		bcs ui
		
o2		inc man_el_l,x
		bne lp
		inc man_el_h,x
                gne lp
                
chk     	ldy man_el_h,x
		sec
                adc man_el_l,x
		bcc *+3
		iny
		cmp man_files_l,x
		tya
		sbc man_files_h,x
		rts
		.pend
;---------------------------
; Manager data swap
;
manager_data_swap2andrestore .proc
		jsr restorescreen
manager_data_swap2 .proc
		lda selectedwin
                sta man_selectedwin
		lda m_d018
                sta man_font
manager_data_swap .proc
		jsr newclall_t
		#sta_cfg_open
		lda #<man_data
                sta m_p3
		lda #>man_data
                sta m_p3+1
		lda #<manager_data_exp
                sta m_p1
		lda #>manager_data_exp
                sta m_p1+1
                .if SUPERCPU=1
                ldy #1
                sty m_p1+2
                dey
                .else
                ldy #0
                .fi
lp		#ldatax (m_p3),y
                #lda_zp_y m_p1
                sta (m_p3),y
                txa
                #sta_zp_y m_p1
                dey
                bne lp
                inc m_p1+1
                inc m_p3+1
                lda m_p3+1
                cmp #>man_data_end
                bne lp
                #sta_cfg_16
                rts
		.pend

;---------------------------
; Check/set manager sign
;
man_check_sign	.proc
		sec
set		ldx #38
ldl             #sta_cfg_open
                lda ident_label_exp-1,x
                #sta_cfg_16
                bcc vdv
                cmp man_ident_label-1,x
                bne vs
vdv             sta man_ident_label-1,x
                dex
                bne ldl
vs              rts
                .pend
;---------------------------
; Same directory?
;
same_dir	.proc
		jsr same_part
                bne no
                tax
nvs             lda man_relpath,x
                cmp man_relpath+$100,x
                bne no
                tay
                beq no
                inx
                bne nvs
no		rts
		.pend
;---------------------------
; Same partition?
;
same_part	.proc
                lda man_drive
                eor man_drive+1
                bne no
                lda man_partition
                eor man_partition+1
no		rts		;A=0 if Z=1!!!
		.pend
;---------------------------
; Z=1 if there are no files or it's a partition list
;
no_files_or_partlist_or_virtual .proc
		lda man_virtual,x
                cmp #1
                beq no_files_or_partlist.xke
no_files_or_partlist .proc
		lda man_files_l,x
		ora man_files_h,x
                beq xke
                lda man_parlist,x
		cmp #3
xke             rts
                .pend
;---------------------------
; Append the filename to path
;
append_actualfn_plus3_to_path .proc
		lda ActualFilename
		clc
                adc #3
                sta ActualFilename
                bcc *+4
                inc ActualFilename+2

append_actualfn_to_path .proc
                jsr rel_path_m_p1s
                
                ldx #0
dmf             lda (ActualFilename,x)
                beq mfd
                sta (m_p1),y
                inc ActualFilename
                bne *+4
                inc ActualFilename+1
                iny
                bne dmf
mfd		lda #"/"
		sta (m_p1),y
                iny
                txa
                sta (m_p1),y
                rts
                .pend
;---------------------------
; Remove last part of path
;
remove_last_path_part .proc
		jsr rel_path_m_p1s
                cpy #4
                bne kx
                rts

ini		jsr rel_path_m_p1
		ldy #3
nu              lda #"/"
                sta man_input+3
		ldx #4
		gne in

kx              dey
                lda #"/"
jcn             dey
		cpy #5
		bcc ini
                cmp (m_p1),y
                bne jcn

in      	lda #"/"
		sta (m_p1),y
                iny
                #ldatax (m_p1),y
		#lda0
                sta (m_p1),y
                rts
                .pend
;---------------------------
; Go to the top 
;
gotop           .proc
		#stz_a man_bar,x
                #stz_aa man_el_l,x
                #stz_aa man_el_h,x
                rts
                .pend
;---------------------------
; Filename is ".."?
;
ispp            .proc
		clc
point		ldy #3
                lda #"."
                bcs fg
                cmp (m_p1),y
                bne mvm
                iny
fg              cmp (m_p1),y
                bne mvm
                iny
                lda (m_p1),y
mvm		rts
		.pend
;---------------------------
; Set current device
;
setdev		.proc
		ldx selectedwin
		lda man_drive,x
		sta ActualDev
		rts
                .pend
;---------------------------
; Restore screen settings
;
restorescreen	.proc
		clc
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
save		ldx #46
vlp2		ldy man_old646,x
		lda man_oldvic,x
		bcc ie
                ldy 646,x
                lda $d000,x
ie      	sta $d000,x
		sta man_oldvic,x
		tya
                sta 646,x
                sta man_old646,x
		dex
		bpl vlp2
;---------------------------
; clear screen
;
clrscr		.proc
                lda #147
		jmp $ffd2
		.pend
;---------------------------
; Kill virtual filesystem
;
killvirtualredrwincap .proc
		jsr redrwincap
killvirtual	.proc
                jsr rel_path_m_p1
                ldy #255
nx              iny
		lda (m_p1),y
                beq du
                eor #":"
                bne nx
                iny
                sta (m_p1),y
                dey
                lda #"/"
                sta (m_p1),y
du		rts
                .pend
;---------------------------
; Filename setup
;
setnameinput    .proc
		ldx #<man_input
		ldy #>man_input
                gne setname201.in

setname200	.proc
		lda $200
setname201      .proc
		ldx #<$201
                ldy #>$201
in              jmp $ffbd
		.pend

updateselectedwin .proc
		and #1
                sta selectedwin
                eor #1
                sta selectedwin+1
                rts
                .pend

  ;      	.if *>$9e60
 ;       	.error "Bank2 block $8000-$9e60 over!"
;		.fi
